<template>
  <div>
    <q-card class="bg-transparent no-shadow no-border">
      <q-card-section class="q-px-lg q-pb-lg q-mb-sm">
        <div class="text-h6">Current Price Data</div>
        <div class="row q-col-gutter-sm ">
          <text-metric
            :bgColor="'bg-orange'"
            :textColor="'text-white'"
            :value="`$${tickerBTCUSDT.toFixed(2)}`"
            :label="'BTC/USDT'"
          ></text-metric>
          <text-metric
            :bgColor="'bg-indigo'"
            :textColor="'text-white'"
            :value="`${tickerSTXBTC} Sats`"
            :label="'STX/BTC'"
          ></text-metric>
          <text-metric
            :bgColor="'bg-indigo'"
            :textColor="'text-white'"
            :value="`$${tickerSTXUSDT}`"
            :label="'STX/USDT'"
          ></text-metric>
          <text-metric
            :bgColor="'bg-orange'"
            :textColor="'text-white'"
            :value="baseRewardValue"
            :label="'Base Reward Value'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="'17.2'"
            :label="'Current Balance'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="'43808 STX'"
            :label="'Current Balance'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="'0.5 BTC'"
            :label="'Last Commitment'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="'0.63 BTC'"
            :label="'Avg Commitment'"
          ></text-metric>
        </div>
      </q-card-section>

      <q-card-section
        class="q-mt-sm q-pa-lg"
        style="border: 1px solid indigo; border-radius: 8px;"
      >
        <div class="row">
          <div class="text-h6">Stacks Chain State</div>
          <q-space />
          <div>Contract ID: {{ poxInfo.contract_id }}</div>
        </div>
        <div class="row q-col-gutter-sm ">
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="stackingMinimum"
            :label="'Stacking Minimum (uSTX)'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="'30 blocks'"
            :label="'Prepare Cycle Length'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="'25 %'"
            :label="'Rejection Fraction'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="35"
            :label="'Reward Cycle'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="120"
            :label="'Reward Cycle Length'"
          ></text-metric>

          <!-- <chart-metric :data="[[1,10],[2,11],[3,10],[4,15],[5,20],[6,25],[7,35]]"></chart-metric> -->
        </div>
      </q-card-section>
      <q-card-section
        class="q-pa-lg q-mt-sm"
        style="border: 1px solid orange; border-radius: 8px;"
      >
        <div class="text-h6">Bitcoin Chain State</div>
        <div class="row q-col-gutter-sm ">
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="btcInfo.height"
            :label="'Bitcoin Block Height'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="(btcInfo.high_fee_per_kb / 1024).toFixed(0) + ' Sats'"
            :label="'High Fee'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="(btcInfo.medium_fee_per_kb / 1024).toFixed(0) + ' Sats'"
            :label="'Average Fee'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="(btcInfo.low_fee_per_kb / 1024).toFixed(0) + ' Sats'"
            :label="'Low Fee'"
          ></text-metric>
          <text-metric
            :bgColor="'transparent'"
            :textColor="'text-grey-10'"
            :value="btcInfo.unconfirmed_count"
            :label="'Mempool Depth'"
          ></text-metric>
          <text-metric
            :bgColor="'orange'"
            :textColor="'white'"
            :value="btcTxnFees.fastestFee"
            :label="'Recommended Fastest Fee'"
          ></text-metric>
          <text-metric
            :bgColor="'orange'"
            :textColor="'white'"
            :value="btcTxnFees.halfHourFee"
            :label="'Recommended 30 Min Fee'"
          ></text-metric>
          <text-metric
            :bgColor="'orange'"
            :textColor="'white'"
            :value="btcTxnFees.hourFee"
            :label="'Recommended 60 Min Fee'"
          ></text-metric>
        </div>
        <div class="row q-col-gutter-sm "></div>
      </q-card-section>
    </q-card>

    <div class="row q-col-gutter-sm  q-py-sm">
      <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
        <q-card>
          <q-tabs
            v-model="tab"
            dense
            class="text-grey"
            active-color="primary"
            indicator-color="primary"
            align="justify"
          >
            <q-tab
              name="errors"
              :class="tab == 'errors' ? 'text-secondary' : ''"
              icon="contacts"
              label="Errors"
            />
            <q-tab
              name="warnings"
              :class="tab == 'warnings' ? 'text-secondary' : ''"
              icon="comment"
              label="Warnings"
            >
              <q-badge color="red" floating>{{ messages.length }}</q-badge>
            </q-tab>
            <q-tab
              name="notifications"
              :class="tab == 'notifications' ? 'text-secondary' : ''"
              icon="notifications"
              label="Notifications"
            >
              <q-badge color="red" floating>4</q-badge>
            </q-tab>
          </q-tabs>

          <q-separator />

          <q-tab-panels v-model="tab" animated>
            <q-tab-panel name="errors" class="q-pa-sm">
              <q-list class="rounded-borders" separator>
                <q-item
                  clickable
                  v-ripple
                  v-for="(error, index) in errors"
                  :key="index"
                >
                  <q-item-section>
                    <q-item-label caption lines="2">
                      <span class="">{{ error }}</span>
                    </q-item-label>
                  </q-item-section>
                </q-item>
              </q-list>
            </q-tab-panel>

            <q-tab-panel name="warnings" class="q-pa-sm">
              <q-item v-for="msg in messages" :key="msg.id" clickable v-ripple>
                <q-item-section avatar>
                  <q-avatar>
                    <img :src="msg.avatar" />
                  </q-avatar>
                </q-item-section>

                <q-item-section>
                  <q-item-label>{{ msg.name }}</q-item-label>
                  <q-item-label caption lines="1">{{ msg.msg }}</q-item-label>
                </q-item-section>

                <q-item-section side>
                  {{ msg.time }}
                </q-item-section>
              </q-item>
            </q-tab-panel>

            <q-tab-panel name="notifications" class="q-pa-sm">
              <q-list>
                <q-item clickable v-ripple>
                  <q-item-section avatar>
                    <q-avatar color="teal" text-color="white" icon="info" />
                  </q-item-section>

                  <q-item-section>Avatar-type icon</q-item-section>
                </q-item>
                <q-item clickable v-ripple>
                  <q-item-section avatar>
                    <q-avatar color="teal" text-color="white" icon="report" />
                  </q-item-section>

                  <q-item-section>Avatar-type icon</q-item-section>
                </q-item>
                <q-item clickable v-ripple>
                  <q-item-section avatar>
                    <q-avatar color="teal" text-color="white" icon="remove" />
                  </q-item-section>

                  <q-item-section>Avatar-type icon</q-item-section>
                </q-item>

                <q-item clickable v-ripple>
                  <q-item-section avatar>
                    <q-avatar
                      color="teal"
                      text-color="white"
                      icon="remove_circle_outline"
                    />
                  </q-item-section>

                  <q-item-section>Avatar-type icon</q-item-section>
                </q-item>
              </q-list>
            </q-tab-panel>
          </q-tab-panels>
        </q-card>
      </div>

      <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
        <q-card class="bg-black text-white">
          <q-card-section>
            <div class="absolute-top text-center text-h5">
              Stacks Node Health
            </div>
          </q-card-section>
          <q-separator />
          <q-card-section>
            <div>Uptime: {{ uptime }}</div>
            <div>CPU Usage: {{ currentLoad.toFixed(2) }}%</div>
            <div>CPU Temp: {{ temp }}<sup>o</sup>C</div>
            <div>
              Memory Usage: {{ formatGBSize(memTotal - memFree) }} /
              {{ formatGBSize(memTotal) }} | {{ memDisplay }} Free
            </div>
          </q-card-section>
          <q-card-section>
            <div>File systems:</div>
            <q-list dense>
              <q-item v-for="fs in fileSystems" :key="fs.mount">
                <q-item-section avatar>
                  {{ fs.mount }}
                </q-item-section>
                <q-item-section
                  >{{ formatGBSize(fs.used) }} / {{ formatGBSize(fs.size) }} |
                  {{ fs.use }} %
                </q-item-section>
              </q-item>
            </q-list>
          </q-card-section>
          <q-card-actions vertical align="center">
            <div class="text-caption">
              Last updated: {{ osDashboardLastUpdate }}
            </div>
          </q-card-actions>
        </q-card>
      </div>
    </div>
  </div>
</template>

<script>
import { exportFile, date } from "quasar";
import TextMetric from "components/TextMetric";
// import ChartMetric from "components/ChartMetric";

const shell = require("shelljs");
const si = require("systeminformation");
const CoinGecko = require("coingecko-api");
const CoinGeckoClient = new CoinGecko();

export default {
  name: "PageIndex",
  components: {
    TextMetric
    // ChartMetric
  },
  data() {
    return {
      btcInfo: {},
      poxInfo: {},
      btcTxnFees: { fastestFee: 0, halfHourFee: 0, hourFee: 0 },
      systemVals: {
        time: "uptime",
        cpuTemperature: "main",
        mem: "total,free",
        fsSize: "size,used,fs,use, mount",
        currentLoad: "currentload"
      },
      memDisplay: 0,
      temp: 0,
      memFree: 0,
      memTotal: 0,
      diskSize: 0,
      diskUsedInGb: 0,
      diskUsedInPct: 0,
      uptime: 0,
      currentLoad: 0,
      fileSystems: [],
      osDashboardLastUpdate: 0,
      tickerData: [],
      filter: "",
      mode: "list",
      tab: "errors",
      layout: "dense",
      side: "right",
      messages: [
        {
          id: 5,
          name: "Pratik Patel",
          msg:
            " -- I'll be in your neighborhood doing errands this\n" +
            "            weekend. Do you want to grab brunch?",
          avatar: "https://avatars2.githubusercontent.com/u/34883558?s=400&v=4",
          time: "10:42 PM"
        },
        {
          id: 6,
          name: "Winfield Stapforth",
          msg:
            " -- I'll be in your neighborhood doing errands this\n" +
            "            weekend. Do you want to grab brunch?",
          avatar: "https://cdn.quasar.dev/img/avatar6.jpg",
          time: "11:17 AM"
        },
        {
          id: 1,
          name: "Boy",
          msg:
            " -- I'll be in your neighborhood doing errands this\n" +
            "            weekend. Do you want to grab brunch?",
          avatar: "https://cdn.quasar.dev/img/boy-avatar.png",
          time: "5:17 AM"
        },
        {
          id: 2,
          name: "Jeff Galbraith",
          msg:
            " -- I'll be in your neighborhood doing errands this\n" +
            "            weekend. Do you want to grab brunch?",
          avatar: "https://cdn.quasar.dev/team/jeff_galbraith.jpg",
          time: "5:17 AM"
        },
        {
          id: 3,
          name: "Razvan Stoenescu",
          msg:
            " -- I'll be in your neighborhood doing errands this\n" +
            "            weekend. Do you want to grab brunch?",
          avatar: "https://cdn.quasar.dev/team/razvan_stoenescu.jpeg",
          time: "5:17 AM"
        }
      ],
      errors: [
        "Oct 04 09:59:54 ip-172-26-13-130 stacks-node[1338]: DEBUG [1601805594.943] [src/chainstate/stacks/index/marf.rs:543] [ThreadId(6)] Extend 38d5eab3b17d2dc3ab0870ff262168992b74887de85b129d78ec07ab355317c4 to 8acfc67a3275c40f79e19f179fd70408cd12eb8e19ef794e>",
        "Oct 04 09:59:54 ip-172-26-13-130 stacks-node[1338]: DEBUG [1601805594.944] [src/chainstate/stacks/index/marf.rs:289] [ThreadId(6)] Set __MARF_BLOCK_HEIGHT_TO_HASH::3063 = 8acfc67a3275c40f79e19f179fd70408cd12eb8e19ef794e5127498dac2d09b4",
        "Oct 04 09:59:54 ip-172-26-13-130 stacks-node[1338]: DEBUG [1601805594.946] [src/chainstate/stacks/index/marf.rs:290] [ThreadId(6)] Set __MARF_BLOCK_HASH_TO_HEIGHT::8acfc67a3275c40f79e19f179fd70408cd12eb8e19ef794e5127498dac2d09b4 = 3063",
        "Oct 04 09:59:54 ip-172-26-13-130 stacks-node[1338]: DEBUG [1601805594.946] [src/chainstate/stacks/index/marf.rs:291] [ThreadId(6)] Set __MARF_BLOCK_HEIGHT_SELF = 3063",
        "Oct 04 09:59:54 ip-172-26-13-130 stacks-node[1338]: DEBUG [1601805594.947] [src/chainstate/stacks/index/marf.rs:306] [ThreadId(6)] Set __MARF_BLOCK_HEIGHT_TO_HASH::3062 = 38d5eab3b17d2dc3ab0870ff262168992b74887de85b129d78ec07ab355317c4",
        "Oct 04 09:59:54 ip-172-26-13-130 stacks-node[1338]: DEBUG [1601805594.947] [src/chainstate/stacks/index/marf.rs:307] [ThreadId(6)] Set __MARF_BLOCK_HASH_TO_HEIGHT::38d5eab3b17d2dc3ab0870ff262168992b74887de85b129d78ec07ab355317c4 = 3062"
      ]
    };
  },
  created() {
    const pox = this.$axios.get("http://krypton.blockstack.org:20443/v2/pox");
    const btc = this.$axios.get("https://api.blockcypher.com/v1/btc/main");

    Promise.all([pox, btc]).then(responses => {
      this.btcInfo = responses[1].data;
      this.poxInfo = responses[0].data;
      console.log("pox info: ", this.poxInfo);
    });
  },
  async mounted() {
    this.getSystemInfo();
    this.tickerData = await CoinGeckoClient.exchanges.fetchTickers("binance", {
      coin_ids: ["bitcoin", "blockstack"]
    });
    this.tickerData = this.tickerData.data.tickers.filter(ticker => {
      if (
        (ticker.base === "BTC" && ticker.target === "USDT") ||
        (ticker.base === "STX" && ticker.target === "USDT") ||
        (ticker.base === "STX" && ticker.target === "BTC")
      ) {
        console.log("ticker: ", ticker);
        return ticker;
      }
    });
    this.btcTransactionFees();
  },
  computed: {
    tickerBTCUSDT() {
      let ticker = this.tickerData.find(
        ticker => ticker.base === "BTC" && ticker.target === "USDT"
      );
      if (ticker !== undefined) {
        return ticker.last;
      } else {
        return 0;
      }
    },
    tickerSTXBTC() {
      console.log("ticker data: ", this.tickerData);
      const stxTicker = this.tickerData.find(({ base }) => base === "STX");
      return stxTicker.converted_last.btc * 100000000;
      // let ticker = this.tickerData.find(
      //   ticker => ticker.base === "STX" && ticker.target === "BTC"
      // );
      // if (ticker !== undefined) {
      //   return ticker.last;
      // } else {
      //   return 0;
      // }
    },
    tickerSTXUSDT() {
      let ticker = this.tickerData.find(
        ticker => ticker.base === "STX" && ticker.target === "USDT"
      );
      if (ticker !== undefined) {
        return ticker.last;
      } else {
        return 0;
      }
    },
    baseRewardValue() {
      // TODO: pull block reward from STX chain
      // base block reward changd from 500 to 1000
      // for early mining.  wen change?
      return this.tickerSTXBTC * 500 + " Sats";
    },
    stackingMinimum() {
      // TODO: probably shouldnt fix to 4 decimal places
      // stacking amounts are going to round up to the next
      // 10000, iirc and max is 1 / 5000th of total supply
      return (this.poxInfo.min_amount_ustx / 1000000).toFixed(4);
    }
  },
  methods: {
    btcTransactionFees() {
      this.$axios
        .get("https://bitcoinfees.earn.com/api/v1/fees/recommended")
        .then(res => {
          console.log("btc txn fees: ", res);
          this.btcTxnFees = res.data;
        })
        .catch(err => {
          console.log("error: ", err);
        });
    },
    formatGBSize(size) {
      return (size / 8589934592).toFixed(2) + "GB";
    },
    exportTable() {
      // naive encoding to csv format
      const content = [this.columns.map(col => wrapCsvValue(col.label))]
        .concat(
          this.data.map(row =>
            this.columns
              .map(col =>
                wrapCsvValue(
                  typeof col.field === "function"
                    ? col.field(row)
                    : row[col.field === void 0 ? col.name : col.field],
                  col.format
                )
              )
              .join(",")
          )
        )
        .join("\r\n");

      const status = exportFile("table-export.csv", content, "text/csv");

      if (status !== true) {
        this.$q.notify({
          message: "Browser denied file download...",
          color: "negative",
          icon: "warning"
        });
      }
    },
    getSystemInfo() {
      si.get(this.systemVals).then(data => {
        this.temp = data.cpuTemperature.main;
        this.memTotal = data.mem.total;
        this.memFree = data.mem.free;
        this.memDisplay = ((data.mem.free / data.mem.total) * 100).toFixed(2);
        this.fileSystems = data.fsSize;
        this.uptime = data.time.uptime;
        this.currentLoad = data.currentLoad.currentload;
        this.osDashboardLastUpdate = date.formatDate(
          Date.now(),
          "YYYY-MM-DD hh:mm:ss"
        );
      });
      setTimeout(this.getSystemInfo, 5000);
    }
  }
};
</script>
